#include <stdio.h>
#include <string.h>
#include "includes.h"
#include "../tmalib/tmalib.h"

int readpathsfile(char *file)
{
    FILE *openf;
    char str[CHAR_MAX];

    if( ( openf = fopen( file, "r" ) ) == NULL )
    {
	fprintf( stderr, "OPENFILE \"%s\" file don't exist!\n", file );
	return( -1 );
    }

    while( fgets( str, sizeof(str)-1, openf ) != NULL )
    {
	// ""  \n
	skip_crlf( str );
	//    \t    .
	if( str[0] == '!' )
	{
	    //    - '!',     
	    // .
#ifndef	DONOT_STDOUT
	    fprintf( stdout, "Don't recursive scaning: %s\n", str+1 );
#endif	/* DONOT_STDOUT */
	    scandirectory( skip_all_spaces( str+1 ), 0 );
	}
	else
	    scandirectory( skip_all_spaces( str ), -1 );
    }

    fclose( openf );

    return( 0 );
}
