#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include "includes.h"

FIND_TYPE *find;

#ifdef	DESC
char *read_desc()
{
    FILE *f;
    int i = 0;
    char desc_file[PATH_MAX];
    char str[CHAR_MAX];

    //      *.desc
#ifdef	WIN32
    sprintf( desc_file, "%s\\.desc\\%s.desc", find->path, find->file );
#else
    snprintf( desc_file, sizeof(desc_file)-1, "%s/.desc/%s.desc",
     find->path, find->file );
#endif

    if( ( f = fopen( desc_file, "r" ) ) == NULL )
    {
	//    -  NO_DESC_FILE
#ifdef	NO_DESC_FILE
	DESC_STR = strdup( NO_DESC_FILE );
#else
	DESC_STR = strdup( "Ok" );
#endif	/* NO_DESC_FILE */
	return( DESC_STR );
    }

#ifdef	DEBUG
    printf( "Read \"%s\" file\n-------------------------------------\n",
     desc_file );
#endif	/* DEBUG */

    while( fgets( str, CHAR_MAX, f ) != NULL )
    {
	i++;	//  .
	//      - .
	if( DESC_STR == NULL )
		{ DESC_STR = malloc( CHAR_MAX ); strcpy( DESC_STR, "\0" ); }
	else DESC_STR = realloc( DESC_STR, CHAR_MAX * i );
	//   DESC_STR    .
#ifdef	DEBUG
	printf( "%d: %s", i, str );
#endif	/* DEBUG */
	strncat( DESC_STR, str, CHAR_MAX );
    }

    fclose( f );	//  .

    // .desc -  .
#ifdef	NO_DESC_FILE
    if( !i ) DESC_STR = strdup( NO_DESC_FILE );
#else
    if( !i ) DESC_STR = strdup( "Ok" );
#endif	/* NO_DESC_FILE */

#ifdef	DEBUG
    if( !i ) printf( "%s", DESC_STR );
    printf( "\n-------------------------------------\n" );
#endif	/* DEBUG */

    //      '\0'
    if( !i )
	DESC_STR = realloc( DESC_STR, ( CHAR_MAX ) + 1 );
    else
	DESC_STR = realloc( DESC_STR, ( CHAR_MAX * i ) + 1 );
    strcat( DESC_STR, "\0" );
    //    ...
    DESC_STR = realloc( DESC_STR, strlen( DESC_STR ) + 2 );
    strcat( DESC_STR, "\0" );

#ifdef	DEBUG
    printf( " \"%s\":\n", desc_file );
    printf( "-------------------------------------\n" );
    printf( "%s\n", DESC_STR );
    printf( "-------------------------------------\n" );
#endif	/* DEBUG */

    return( DESC_STR );
}

//  ,   DESC_STR.
void free_desc()
{
    free( DESC_STR );
    DESC_STR = NULL;
}
#endif	/* DESC */
