#include <stdio.h>
#include <unistd.h>
#include <limits.h>
#include "tmafreqlib.h"

/*	 __ 					*/
/*	   koi8-r  alt        */
/*	  \x0D \x0A					*/
int copyascfile_koi82alt(char *oldfile, char *newfile)
{
	FILE *f, *ff;
	int i;
	char str[CHAR_MAX], str2[CHAR_MAX], *newstr;

	//   -  
	if( ( f = fopen( oldfile, "r" ) ) == NULL ) return( -1 );

	//   -  
	//   - ,    - .
	if( ( ff = fopen( newfile, "w" ) ) == NULL )
	{
		fclose( f );
		//  , ..    .
		unlink( newfile );
		return( -1 );
	}

	//       .
	while( fgets( str, sizeof(str)-1, f ) != NULL )
	{
		//   ,    '\r'  '\n'
		i = 0;
		while( str[i] != '\r' && str[i] != '\n' && str[i] != 0 )
		{
			str2[i] = str[i];
			if( ++i >= CHAR_MAX ) break;
		}
		//     \x00
		if( i >= CHAR_MAX ) i = CHAR_MAX-1;
		str2[i] = 0;
		//  str  koi8-r  alt
		newstr = koi2alt( str2 );
		//    2
		fputs( newstr, ff );
		//   \x0D & \x0A
#ifdef	WIN32
		fputs( "\n", ff );
#else
		fputs( "\r\n", ff );
#endif	/* WIN32 */
	}

	//   
	fclose( f );
	fclose( ff );

	return( 0 );
}
